#include <unistd.h>
#include <stdlib.h>

#include <gtk/gtk.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <string.h>
#include <pthread.h>

#define TAILLE_BUFF 100

// Un petit mutex
pthread_mutex_t fastmutex = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t cond = PTHREAD_COND_INITIALIZER;

// Fonctions du fichier interdit
extern GtkWindow *win;
void initialisation(int argc, char* argv[]);
void
affiche(const char *text, const char *prefix);

// Les variables globales pour l'échange
int nouveau_message = FALSE;
char message[TAILLE_BUFF];



char * ecoute() {
  // Cette fonction est appellée quand on clique sur le bouton ecoute
  // Elle lit sur la socket 
  //
  // On retrouve la socket
  int socket = GPOINTER_TO_INT(gtk_object_get_data(GTK_OBJECT(win), "socket"));


  char *buff = (char *) malloc(TAILLE_BUFF*sizeof(char));

  // On lit
  int retval = recv(socket, (char*)buff, TAILLE_BUFF, 0);
  if ( retval < 0 ) {
    perror("probleme de reception sur le client");
    pthread_exit(GINT_TO_POINTER(57));
  }

  return buff;

}

void producteur(const char *argument){
  fprintf(stdout, "Lancement du producteur avec l'argument %s\n", argument);
  char * mess;
  int res;

  while (1) {
    mess = ecoute();


    //########################################################
    // part 3
    // Décomenter pour mettre en place les mutex
    res = pthread_mutex_lock(&fastmutex);
    if (res) {
      fprintf(stderr, "problème pour l'acquisition du mutex car %sn",strerror(res));
      pthread_exit(GINT_TO_POINTER(25));
    }
    //# Fin ##################################################



    if (nouveau_message) { 
       // Il n'y a plus de place 
      //########################################################
      // part 4
      // Commenter ça pour mettre en place les variables de condition
      // fprintf(stderr, "Il n'y a plus de place\n");
      // exit(1);
      // Décomenter pour mettre en place les variables de condition
      res = pthread_cond_wait(&cond, &fastmutex);
      if (res) {
	fprintf(stderr, "problème pour le wait car %sn",strerror(res));
	pthread_exit(GINT_TO_POINTER(25));
      }
      //# Fin ##################################################

    } 

    nouveau_message = TRUE; // On signale la présence s'un nouveau message

    //########################################################
    // part 2
    // Décomenter pour tester la section critique
    // sleep(1);
    //# Fin ##################################################
    
    strncpy(message, mess, TAILLE_BUFF); // Copie le nouveau message dans la variable partagée

    //########################################################
    // part 3
    // Décomenter pour mettre en place les mutex    
    res = pthread_mutex_unlock(&fastmutex);
    if (res) {
      fprintf(stderr, "problème pour la libération du mutex car %s\n",strerror(res));
      pthread_exit(GINT_TO_POINTER(25));
    }
    //# Fin ##################################################

    free(mess);
  }
}

gboolean consomateur(void *rien) {
  int res;

  //########################################################
  // part 3
  // Décomenter pour mettre en place les mutex
  res = pthread_mutex_lock(&fastmutex);
  if (res) {
    fprintf(stderr, "problème pour l'acquisition du mutex car %s\n", strerror(res));
    pthread_exit(GINT_TO_POINTER(25));
  }
  //########################################################
  // part 3.bis
  // Mettre à la place de lock pour une attente active
  // res = pthread_mutex_trylock(&fastmutex);
  // if (res) {
  //       fprintf(stderr,"problème pour la libération du mutex car %s\n", strerror(res));

  //   return TRUE;
  //   //    pthread_exit(GINT_TO_POINTER(25));
  // }
  //# Fin ##################################################
  
  if (!(nouveau_message)) {
    // il n'y a pas de nouveau message à lire
  } else {
    affiche(message, "# "); //On écrit le message sur la fenêtre précédé de # . 
    nouveau_message = FALSE; // On signale que le message à été lu

    //########################################################
    // part 4
    // Décomenter pour mettre en place les variables de condition
    res = pthread_cond_signal(&cond);
    if (res) {
      fprintf(stderr, "problème pour le signal car %s\n", strerror(res));
      pthread_exit(GINT_TO_POINTER(25));
    }
    //# Fin ##################################################
  }

  //########################################################
  // part 3
  // Décomenter pour mettre en place les mutex
  res = pthread_mutex_unlock(&fastmutex);
  if (res) {
    fprintf(stderr,"problème pour la libération du mutex car %s\n", strerror(res));
    pthread_exit(GINT_TO_POINTER(25));
  }
  //# Fin ##################################################

  return TRUE; // On retourne TRUE parce que c'est comme ça.
}


int
main (int argc, char *argv[])
{
  int res;
  pthread_t thr;

  initialisation(argc, argv);

  if (argc == 2) {
    fprintf(stdout, "Je suis le serveur écoute sur le port %s\n", argv[1]);
  } else {
    fprintf(stdout, "Je suis le client envoie à %s:%s\n", argv[1], argv[2]);

    //########################################################
    // part 1
    // Décomenter pour lancer les threads
    res = pthread_create(&thr, NULL, (void*)producteur, (void *)"coucou" );
    if (res) {
      fprintf(stderr, "erreur avec la creation de thread car %s\n", strerror(res) );
      exit(1);
    }
    //# Fin ##################################################
  }
  

  //fonction qui permet d'appeler régulierement le consomateur
  g_timeout_add(5000, //nb de milliseconde entre les appel
		consomateur, // fonction à appeler
		NULL // Argument de la fonction si on en avait besoin
		);
  
  gtk_main ();


  if (argc != 2) {

    fprintf(stdout, "Je suis le client j'attend la fin du thread\n");

    //########################################################
    // part 1
    // Décomenter pour lancer les threads (slide )
    void *resultat;
    res = pthread_cancel(thr);
    if (res) {
    	     fprintf(stderr, "Probleme avec le cancel car %s\n", strerror(res));
    }
    res = pthread_join(thr, (void **)&resultat);
    if (res) {
       fprintf(stderr, "Probleme avec le cancel car %s\n", strerror(res));
    }
    
    fprintf(stdout, "Je suis le client le thread a rendu %d\n", GPOINTER_TO_INT(resultat));
    //# Fin ##################################################

  }
  

  return 0;
}

